import java.io.*;
import java.util.*;

public class TemplateIO {
	public void solve() throws IOException {
		String s=br.readLine();
		String a[]=s.split("\\s");
		int n = Integer.parseInt(a[0]);
		int m = Integer.parseInt(a[1]);
		int arr[][] = new int[n][2];
		arr[0][1] = 0;
		s=br.readLine();
		String e[]=s.split("\\s");
		for (int i = 1; i < n; i++) {
			arr[i][0] = Integer.parseInt(e[i-1]);
			arr[i][1] = 1 + arr[arr[i][0] - 1][1];
		}
		int maxTime = 0;
		for (int i = 0; i < n; i++) {
			if (arr[i][1] > maxTime) {
				maxTime = arr[i][1];
			}
		}
		int brr[] = new int[maxTime + 1];
		for (int i = 0; i < n; i++) {
			brr[arr[i][1]]++;
		}
		int crr[] = new int[maxTime + 1];
		crr[0] = 0;
		for (int i = 1; i <= maxTime; i++) {
			crr[i] = crr[i - 1] + brr[i - 1];
		}
		int sorted[][] = new int[n][3];// v nulevom lezhit vremya v pervom lezhat otzi vo vtorom "kleimo" otza
		for (int i = 0; i < n; i++) {
			sorted[crr[arr[i][1]]][0] = arr[i][1];
			sorted[crr[arr[i][1]]][1] = arr[i][0];
			crr[arr[i][1]]++;
		}
		int numleaves = 0;
		int nummegafathers = 0;
		for (int i = n - 1; i >= 0; i--) {
			if (sorted[i][2] == 0) {
				numleaves++;
			}
			if (sorted[i][2] > 1) {
				nummegafathers++;
			}
			if (i != 0) {
				sorted[sorted[i][1] - 1][2]++;
			}
		}
		int ltime = 0;// lutsee vryemya mdu listami v dereve
		int chktime = 0;
		if (numleaves == 1) {
			out.println(m * (maxTime + 1));
		} else {
			int j = sorted[n - 1][1];
			int k = 0;
			for (int i = 0; i < n-1 ; i++) {
				if (sorted[i][2] == 0) {
					chktime = 2;
					k = sorted[i][1];
					j = sorted[n - 1][1];
					while (j!=k) {
						chktime++;
						if (k>j) {
							k=arr[k][0];
						}if(k<j) {
							j=arr[j][0];
						}
					}
					if(chktime>ltime) {
						ltime=chktime;
					}
				}
			}
			out.println(ltime+1+2*(m-1) * (maxTime + 1));

		}

	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new TemplateIO().run();
	}

}